A. Prime Subtraction
time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
You are given two integers x and y (it is guaranteed that x>y). You may choose any prime integer p and subtract it any number of times from x. Is it possible to make x equal to y?

Recall that a prime number is a positive integer that has exactly two positive divisors: 1 and this integer itself. The sequence of prime numbers starts with 2, 3, 5, 7, 11.

Your program should solve t independent test cases.

Input
The first line contains one integer t (1≤t≤1000) — the number of test cases.

Then t lines follow, each describing a test case. Each line contains two integers x and y (1≤y<x≤1018).

Output
For each test case, print YES if it is possible to choose a prime number p and subtract it any number of times from x so that x becomes equal to y. Otherwise, print NO.

You may print every letter in any case you want (so, for example, the strings yEs, yes, Yes, and YES will all be recognized as positive answer).

Example
inputCopy
4
100 98
42 32
1000000000000000000 1
41 40
outputCopy
YES
YES
YES
NO
Note
In the first test of the example you may choose p=2 and subtract it once.

In the second test of the example you may choose p=5 and subtract it twice. Note that you cannot choose p=7, subtract it, then choose p=3 and subtract it again.

In the third test of the example you may choose p=3 and subtract it 333333333333333333 times.

AC代码:

  #include<bits/stdc++.h>

 using namespace  std;
#define int long long signed main(){
int _;
cin>>_;
while(_--){
int n,m;
cin>>n>>m;
int x=n-m;
if(x==){
printf("NO\n");
}else{
printf("YES\n");
}
}
return ;
}

B. Kill 'Em All
time limit per test1 second
memory limit per test256 megabytes
inputstandard input
outputstandard output
Ivan plays an old action game called Heretic. He's stuck on one of the final levels of this game, so he needs some help with killing the monsters.

The main part of the level is a large corridor (so large and narrow that it can be represented as an infinite coordinate line). The corridor is divided into two parts; let's assume that the point x=0 is where these parts meet.

The right part of the corridor is filled with n monsters — for each monster, its initial coordinate xi is given (and since all monsters are in the right part, every xi is positive).

The left part of the corridor is filled with crusher traps. If some monster enters the left part of the corridor or the origin (so, its current coordinate becomes less than or equal to 0), it gets instantly killed by a trap.

The main weapon Ivan uses to kill the monsters is the Phoenix Rod. It can launch a missile that explodes upon impact, obliterating every monster caught in the explosion and throwing all other monsters away from the epicenter. Formally, suppose that Ivan launches a missile so that it explodes in the point c. Then every monster is either killed by explosion or pushed away. Let some monster's current coordinate be y, then:

if c=y, then the monster is killed;
if y<c, then the monster is pushed r units to the left, so its current coordinate becomes y−r;
if y>c, then the monster is pushed r units to the right, so its current coordinate becomes y+r.
Ivan is going to kill the monsters as follows: choose some integer point d and launch a missile into that point, then wait until it explodes and all the monsters which are pushed to the left part of the corridor are killed by crusher traps, then, if at least one monster is still alive, choose another integer point (probably the one that was already used) and launch a missile there, and so on.

What is the minimum number of missiles Ivan has to launch in order to kill all of the monsters? You may assume that every time Ivan fires the Phoenix Rod, he chooses the impact point optimally.

You have to answer q independent queries.

Input
The first line contains one integer q (1≤q≤105) — the number of queries.

The first line of each query contains two integers n and r (1≤n,r≤105) — the number of enemies and the distance that the enemies are thrown away from the epicenter of the explosion.

The second line of each query contains n integers xi (1≤xi≤105) — the initial positions of the monsters.

It is guaranteed that sum of all n over all queries does not exceed 105.

Output
For each query print one integer — the minimum number of shots from the Phoenix Rod required to kill all monsters.

Example
inputCopy
2
3 2
1 3 5
4 1
5 2 3 5
outputCopy
2
2
Note
In the first test case, Ivan acts as follows:

choose the point 3, the first monster dies from a crusher trap at the point −1, the second monster dies from the explosion, the third monster is pushed to the point 7;
choose the point 7, the third monster dies from the explosion.
In the second test case, Ivan acts as follows:

choose the point 5, the first and fourth monsters die from the explosion, the second monster is pushed to the point 1, the third monster is pushed to the point 2;
choose the point 2, the first monster dies from a crusher trap at the point 0, the second monster dies from the explosion.

思路:去重,排序,从后往前跑即可。

AC代码:

 #include<bits/stdc++.h>

 using namespace std;

 #define int long long
bool cmp(int a,int b){
return a>b;
}
int arr[];
signed main(){
int _;
cin>>_;
while(_--){
int n,r;
cin>>n>>r;
for(int i=;i<=n+;i++)
arr[i]=;
int cnt=;
map<int,int> mp;
for(int i=;i<=n;i++)
{
int temp;
scanf("%lld",&temp);
if(mp[temp])
continue;
else{
mp[temp]=;
arr[cnt++]=temp;
}
}
sort(arr+,arr+cnt,cmp);
int ans=;
for(int i=;i<=cnt;i++){
arr[i]-=ans*r;
if(arr[i]>){
ans++;
}else{
break;
}
}
printf("%lld\n",ans);
}
return ;
}
/*
2 3 5
1 2 5
1 2
4 1
1 1 1 1
*/

C. Standard Free2play
time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
You are playing a game where your character should overcome different obstacles. The current problem is to come down from a cliff. The cliff has height h, and there is a moving platform on each height x from 1 to h.

Each platform is either hidden inside the cliff or moved out. At first, there are n moved out platforms on heights p1,p2,…,pn. The platform on height h is moved out (and the character is initially standing there).

If you character is standing on some moved out platform on height x, then he can pull a special lever, which switches the state of two platforms: on height x and x−1. In other words, the platform you are currently standing on will hide in the cliff and the platform one unit below will change it state: it will hide if it was moved out or move out if it was hidden. In the second case, you will safely land on it. Note that this is the only way to move from one platform to another.

Your character is quite fragile, so it can safely fall from the height no more than 2. In other words falling from the platform x to platform x−2 is okay, but falling from x to x−3 (or lower) is certain death.

Sometimes it's not possible to come down from the cliff, but you can always buy (for donate currency) several magic crystals. Each magic crystal can be used to change the state of any single platform (except platform on height h, which is unaffected by the crystals). After being used, the crystal disappears.

What is the minimum number of magic crystal you need to buy to safely land on the 0 ground level?

Input
The first line contains one integer q (1≤q≤100) — the number of queries. Each query contains two lines and is independent of all other queries.

The first line of each query contains two integers h and n (1≤h≤109, 1≤n≤min(h,2⋅105)) — the height of the cliff and the number of moved out platforms.

The second line contains n integers p1,p2,…,pn (h=p1>p2>⋯>pn≥1) — the corresponding moved out platforms in the descending order of their heights.

The sum of n over all queries does not exceed 2⋅105.

Output
For each query print one integer — the minimum number of magic crystals you have to spend to safely come down on the ground level (with height 0).

Example
inputCopy
4
3 2
3 1
8 6
8 7 6 5 3 2
9 6
9 8 5 4 3 1
1 1
1
outputCopy
0
1
2
0

题意有点难懂QAQ。

看看代码吧,有点难讲。

AC代码:

 #include<bits/stdc++.h>

 using namespace std;

 #define int long long 

 #define N 200050
int arr[N];
signed main(){
int _;
cin>>_;
while(_--){
int n,m;
scanf("%lld%lld",&n,&m);
for(int i=;i<=m;i++)
arr[i]=;
for(int i=;i<=m;i++)
scanf("%lld",&arr[i]);
int ans=;
arr[m+]=;
for(int i=;i<=m;i++)
{
if(arr[i]-==arr[i+]){ //正好能接住。
i++;
}else{
ans++;// 需要一块板接住。
//cout<<i<<endl;
}
}
cout<<ans<<endl;
}
return ;
}

D. AB-string
time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
The string t1t2…tk is good if each letter of this string belongs to at least one palindrome of length greater than 1.

A palindrome is a string that reads the same backward as forward. For example, the strings A, BAB, ABBA, BAABBBAAB are palindromes, but the strings AB, ABBBAA, BBBA are not.

Here are some examples of good strings:

t = AABBB (letters t1, t2 belong to palindrome t1…t2 and letters t3, t4, t5 belong to palindrome t3…t5);
t = ABAA (letters t1, t2, t3 belong to palindrome t1…t3 and letter t4 belongs to palindrome t3…t4);
t = AAAAA (all letters belong to palindrome t1…t5);
You are given a string s of length n, consisting of only letters A and B.

You have to calculate the number of good substrings of string s.

Input
The first line contains one integer n (1≤n≤3⋅105) — the length of the string s.

The second line contains the string s, consisting of letters A and B.

Output
Print one integer — the number of good substrings of string s.

Examples
inputCopy
5
AABBB
outputCopy
6
inputCopy
3
AAA
outputCopy
3
inputCopy
7
AAABABB
outputCopy
15
Note
In the first test case there are six good substrings: s1…s2, s1…s4, s1…s5, s3…s4, s3…s5 and s4…s5.

In the second test case there are three good substrings: s1…s2, s1…s3 and s2…s3.

思路:

 只要a和b的数量都大于1 或者单个的那个不在首位 就能找到回文串。可以先计算一个字符串除去单个字符总的子串个数。然后开始分块。之后计算单个的在首位的个数。
 

AC代码:

 #include<bits/stdc++.h>

 using namespace std;
#define int long long
vector<int> v;
signed main(){
int n;
cin>>n;
string s;
cin>>s;
for(int i=;i<n;i++){
int cnt=;
while(s[i]==s[i+]){
cnt++;
i++;
}
v.push_back(cnt);
}
int ans=n*(n-)/;// 除去单个的字母
int sum=;
for(int i=;i<v.size();i++){
if(i!=){
sum+=v[i-]-;// 除去重复
}
if(i!=v.size()-){
sum+=v[i+];
}
}
int res=ans-sum;
cout<<res<<endl;
return ;
}

Educational Codeforces Round 74 (Rated for Div. 2)【A,B,C【贪心】,D【正难则反的思想】】的更多相关文章

  1. Educational Codeforces Round 74 (Rated for Div. 2) D. AB-string

    链接: https://codeforces.com/contest/1238/problem/D 题意: The string t1t2-tk is good if each letter of t ...

  2. Educational Codeforces Round 74 (Rated for Div. 2) C. Standard Free2play

    链接: https://codeforces.com/contest/1238/problem/C 题意: You are playing a game where your character sh ...

  3. Educational Codeforces Round 74 (Rated for Div. 2) B. Kill 'Em All

    链接: https://codeforces.com/contest/1238/problem/B 题意: Ivan plays an old action game called Heretic. ...

  4. Educational Codeforces Round 74 (Rated for Div. 2) A. Prime Subtraction

    链接: https://codeforces.com/contest/1238/problem/A 题意: You are given two integers x and y (it is guar ...

  5. Educational Codeforces Round 74 (Rated for Div. 2)

    传送门 A. Prime Subtraction 判断一下是否相差为\(1\)即可. B. Kill 'Em All 随便搞搞. C. Standard Free2play 题意: 现在有一个高度为\ ...

  6. Educational Codeforces Round 74 (Rated for Div. 2)补题

    慢慢来. 题目册 题目 A B C D E F G 状态 √ √ √ √ × ∅ ∅ //√,×,∅ 想法 A. Prime Subtraction res tp A 题意:给定\(x,y(x> ...

  7. Educational Codeforces Round 74 (Rated for Div. 2)E(状压DP,降低一个m复杂度做法含有集合思维)

    #define HAVE_STRUCT_TIMESPEC#include<bits/stdc++.h>using namespace std;char s[100005];int pos[ ...

  8. Educational Codeforces Round 33 (Rated for Div. 2) D题 【贪心:前缀和+后缀最值好题】

    D. Credit Card Recenlty Luba got a credit card and started to use it. Let's consider n consecutive d ...

  9. Educational Codeforces Round 77 (Rated for Div. 2)D(二分+贪心)

    这题二分下界是0,所以二分写法和以往略有不同,注意考虑所有区间,并且不要死循环... #define HAVE_STRUCT_TIMESPEC #include<bits/stdc++.h> ...

随机推荐

  1. WUSTOJ 1235: 计算矩阵的鞍点(Java)

    1235: 计算矩阵的鞍点 题目   输出二维数组中行上为最大,列上为最小的元素(称为鞍点)及其位置(行列下标).如果不存在任何鞍点,请输出"404 not found"(不带引号 ...

  2. 一文搞懂嵌入式uboot、kernel、文件系统的关系

    总览: 在linux系统软件架构可以分为4个层次(从低到高分别为):   1.引导加载程序         引导加载程序(Bootloader)是固化在硬件Flash中的一段引导代码,用于完成硬件的一 ...

  3. s5p6818裸机程序的设计:以GPIO为例

    为了调试方便,首先确保对于硬件的控制没有问题. Makefile # Makefile edited by Schips # 2019-06-21 schips@dingtalk.com # 文件类型 ...

  4. RabbitMq的环境安装

    1.如图第一个是erlang语言的安装包,第二个是rabbitmq的安装包. 2.配置erlang语言环境,因为rabbitmq由erlang语言编写的,所以需要配置erlng语言环境. erlang ...

  5. hdu 6182

    A Math Problem Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)To ...

  6. ...:ES6中扩展运算符(spread)和剩余运算符(rest)详解

    1.扩展运算符(spread) demo1:传递数据代替多个字符串的形式 let test= function(a,b,c){ console.log(a); console.log(b); cons ...

  7. Effective Java 读书笔记(二):对象通用方法

    1 重写equals方法时请遵守通用约定 (1)无需覆盖equals方法的情况 要求独一无二 不要求逻辑相等 超类已经覆盖equals方法,对其子类也适用 一个类是私有的或者是包私有(可以重写后抛出异 ...

  8. 八、wepy代码规范

    变量与方法尽量使用驼峰式命名,并且注意避免使用$开头. 以$开头的标识符为WePY框架的内建属性和方法,可在JavaScript脚本中以this.的方式直接使用,具体请参考API文档. 小程序入口.页 ...

  9. testwebsite

    testwebsite ------------------------------------------------------------------ Creating Test environ ...

  10. ES6 class 于 继承 extends

    之前构造函数,没有类的概念,ES6中有了class类这个东西. 简单的一个例子: 输出: 需要注意的是,语法换了,但是构造函数.构造函数的原型.实例的关系还是那样. 输出: 需要注意写法: 底层还是p ...